VERSION 5.00
Begin VB.Form frmChangeBorderStyle 
   AutoRedraw      =   -1  'True
   Caption         =   "Change BorderStyle At RunTime"
   ClientHeight    =   2940
   ClientLeft      =   1860
   ClientTop       =   1500
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   196
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   331
   Begin VB.CommandButton Command1 
      Caption         =   "Make My Border Fixed"
      Height          =   495
      Left            =   1065
      TabIndex        =   0
      Top             =   990
      Width           =   2835
   End
End
Attribute VB_Name = "frmChangeBorderStyle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to manipulate the style bits of a VB
  ' form via the SetWindowLong and GetWindowLong API functions
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  Private Const GWL_STYLE As Long = (-16&)
  Private Const GWL_EXSTYLE As Long = (-20&)
  Private Const WS_THICKFRAME As Long = &H40000
  Private Const WS_MINIMIZEBOX As Long = &H20000
  Private Const WS_MAXIMIZEBOX As Long = &H10000
  
  Private Const WS_EX_TOOLWINDOW As Long = &H80&
  
  Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
  Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd&, ByVal nIndex&, ByVal dwNewLong&) As Long
      

  ' SetWindowPos Flags
  Private Const SWP_NOSIZE = &H1
  Private Const SWP_NOMOVE = &H2
  Private Const SWP_NOZORDER = &H4
  Private Const SWP_NOREDRAW = &H8
  Private Const SWP_NOACTIVATE = &H10
  Private Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
  Private Const SWP_SHOWWINDOW = &H40
  Private Const SWP_HIDEWINDOW = &H80
  Private Const SWP_NOCOPYBITS = &H100
  Private Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering
  
  Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
  Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
  
  ' SetWindowPos() hwndInsertAfter values
  Private Const HWND_TOP = 0
  Private Const HWND_BOTTOM = 1
  Private Const HWND_TOPMOST = -1
  Private Const HWND_NOTOPMOST = -2

  Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd&, ByVal hWndInsertAfter&, ByVal x&, ByVal y&, ByVal cx&, ByVal cy&, ByVal wFlags&) As Long

Private Sub Command1_Click()
  ' toggle the borderstyle depending on the caption of the button
  
  Dim bToggleStyle As Boolean, bToggleExStyle As Boolean

  ' change the button caption to the appropriate string
  ' and set the toggle variables
  With Command1
    Select Case .Caption
      Case "Make My Border Fixed"
        .Caption = "Turn Me Into A Tool Window"
        
        bToggleStyle = True
        
      Case "Turn Me Into A Tool Window"
        .Caption = "Change Me Back, Please!"
        
        bToggleExStyle = True
      
      Case Else
        .Caption = "Make My Border Fixed"
              
        bToggleExStyle = True
        bToggleStyle = True
        
    End Select
  End With
  
  If bToggleStyle Then
    ' this call sets the regular style bits.  in this case, we toggle between
    ' fixed and sizeable borders
    Call SetWindowLong(hWnd, GWL_STYLE, GetWindowLong(hWnd, GWL_STYLE) Xor _
                              (WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX))
  End If

  If bToggleExStyle Then
    ' this call sets the extended style bits.  in this case we toggle between
    ' tool window and regular window style
    Call SetWindowLong(hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) Xor WS_EX_TOOLWINDOW)
  End If

  ' tell the nonclient area of the form to redraw itself
  Call SetWindowPos(hWnd, 0&, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED)
      
End Sub
